Index: code/trunk/src/network/Server.cc
===================================================================
--- code/trunk/src/network/Server.cc	(revision 1639)
+++ code/trunk/src/network/Server.cc	(revision 1735)
@@ -45,11 +45,12 @@
 
 #include "ConnectionManager.h"
-#include "PacketTypes.h"
-#include "GameStateManager.h"
+#include "GamestateManager.h"
 #include "ClientInformation.h"
-//#include "NetworkFrameListener.h"
 #include "util/Sleep.h"
 #include "objects/SpaceShip.h"
 #include "core/ConsoleCommand.h"
+#include "packet/Chat.h"
+#include "packet/Packet.h"
+#include "packet/Welcome.h"
 
 namespace network
@@ -58,32 +59,4 @@
   #define NETWORK_FREQUENCY 30
   
-  Server *Server::instance_=0;
-  
-  Server *Server::createSingleton(){
-    if(!instance_)
-      instance_ = new Server();
-    return instance_;
-  }
-  Server *Server::createSingleton(int port){
-    if(!instance_)
-      instance_ = new Server(port);
-    return instance_;
-  }
-  Server *Server::createSingleton(int port, std::string bindAddress){
-    if(!instance_)
-      instance_ = new Server(port, bindAddress);
-    return instance_;
-  }
-  Server *Server::createSingleton(int port, const char *bindAddress){
-    if(!instance_)
-      instance_ = new Server(port, bindAddress);
-    return instance_;
-  }
-  
-  Server *Server::getSingleton(){
-    return instance_;
-  }
-  
-  
   /**
   * Constructor for default values (bindaddress is set to ENET_HOST_ANY
@@ -92,16 +65,12 @@
   Server::Server() {
     timeSinceLastUpdate_=0;
-    packet_gen = PacketGenerator();
-    clients = new ClientInformation(true);
-    connection = new ConnectionManager(clients);
-    gamestates = new GameStateManager(clients);
+    connection = new ConnectionManager();
+    gamestates_ = new GamestateManager();
   }
   
   Server::Server(int port){
     timeSinceLastUpdate_=0;
-    packet_gen = PacketGenerator();
-    clients = new ClientInformation(true);
-    connection = new ConnectionManager(clients, port);
-    gamestates = new GameStateManager(clients);
+    connection = new ConnectionManager(port);
+    gamestates_ = new GamestateManager();
   }
 
@@ -113,8 +82,6 @@
   Server::Server(int port, std::string bindAddress) {
     timeSinceLastUpdate_=0;
-    packet_gen = PacketGenerator();
-    clients = new ClientInformation();
-    connection = new ConnectionManager(port, bindAddress, clients);
-    gamestates = new GameStateManager(clients);
+    connection = new ConnectionManager(port, bindAddress);
+    gamestates_ = new GamestateManager();
   }
 
@@ -126,8 +93,6 @@
   Server::Server(int port, const char *bindAddress) {
     timeSinceLastUpdate_=0;
-    packet_gen = PacketGenerator();
-    clients = new ClientInformation();
-    connection = new ConnectionManager(port, bindAddress, clients);
-    gamestates = new GameStateManager(clients);
+    connection = new ConnectionManager(port, bindAddress);
+    gamestates_ = new GamestateManager();
   }
 
@@ -148,4 +113,15 @@
   }
 
+  bool Server::processChat(packet::Chat *message, unsigned int clientID){
+    ClientInformation *temp = ClientInformation::getBegin();
+    while(temp){
+      message->setClientID(temp->getID());
+      if(!message->send())
+        COUT(3) << "could not send Chat message to client ID: " << temp->getID() << std::endl;
+      temp = temp->next();
+    }
+    return message->process();
+  }
+  
   /**
   * This function sends out a message to all clients
@@ -153,6 +129,14 @@
   * @return true/false
   */
-  bool Server::sendChat(std::string msg) {
-    return sendChat(msg.c_str());
+  bool Server::sendChat(packet::Chat *chat) {
+    //TODO: change this (no informations about who wrote a message)
+    assert(0);
+    ClientInformation *temp = ClientInformation::getBegin();
+    while(temp){
+      chat->setClientID(temp->getID());
+      if(!chat->send())
+        COUT(3) << "could not send Chat message to client ID: " << temp->getID() << std::endl;
+    }
+    return chat->process();;
   }
 
@@ -162,12 +146,12 @@
   * @return true/false
   */
-  bool Server::sendChat(const char *msg) {
-    char *message = new char [strlen(msg)+10+1];
-    sprintf(message, "Player %d: %s", CLIENTID_SERVER, msg);
-    COUT(1) << message << std::endl;
-    ENetPacket *packet = packet_gen.chatMessage(message);
-    COUT(5) <<"Server: adding Packets" << std::endl;
-    return connection->addPacketAll(packet);
-  }
+//   bool Server::sendChat(const char *msg) {
+//     char *message = new char [strlen(msg)+10+1];
+//     sprintf(message, "Player %d: %s", CLIENTID_SERVER, msg);
+//     COUT(1) << message << std::endl;
+//     ENetPacket *packet = packet_gen.chatMessage(message);
+//     COUT(5) <<"Server: adding Packets" << std::endl;
+//     return connection->addPacketAll(packet);
+//   }
 
   /**
@@ -183,5 +167,5 @@
       timeSinceLastUpdate_=(float)((int)(timeSinceLastUpdate_*NETWORK_FREQUENCY))/timeSinceLastUpdate_;
 //      timeSinceLastUpdate_-=1./NETWORK_FREQUENCY;
-      gamestates->processGameStates();
+      gamestates_->processGamestates();
       updateGamestate();
     }
@@ -191,4 +175,8 @@
     return;
   }
+  
+  bool Server::queuePacket(ENetPacket *packet, int clientID){
+    return connection->addPacket(packet, clientID);
+  }
 
   /**
@@ -197,5 +185,4 @@
   void Server::processQueue() {
     ENetEvent *event;
-    int clientID=-1;
     while(!connection->queueEmpty()){
       //std::cout << "Client " << clientID << " sent: " << std::endl;
@@ -211,13 +198,10 @@
         break;
       case ENET_EVENT_TYPE_DISCONNECT:
-        if(clients->findClient(&event->peer->address))
+        if(ClientInformation::findClient(&event->peer->address))
           disconnectClient(event);
         break;
       case ENET_EVENT_TYPE_RECEIVE:
-        if(clients->findClient(&event->peer->address)){
-          clientID = clients->findClient(&event->peer->address)->getID();
-          if( !elaborate(event->packet, clientID) ) 
-            COUT(3) << "Server: could not elaborate" << std::endl;
-        }
+        if(!processPacket(event->packet, event->peer))
+          COUT(3) << "processing incoming packet failed" << std::endl;
         break;
       default:
@@ -233,5 +217,5 @@
   */
   void Server::updateGamestate() {
-    gamestates->update();
+    gamestates_->update();
     COUT(5) << "Server: one gamestate update complete, goig to sendGameState" << std::endl;
     //std::cout << "updated gamestate, sending it" << std::endl;
@@ -242,4 +226,9 @@
   }
 
+  bool Server::processPacket( ENetPacket *packet, ENetPeer *peer ){
+    packet::Packet *p = packet::Packet::createPacket(packet, peer);
+    return p->process();
+  }
+  
   /**
   * sends the gamestate
@@ -247,15 +236,12 @@
   bool Server::sendGameState() {
     COUT(5) << "Server: starting function sendGameState" << std::endl;
-    ClientInformation *temp = clients;
+    ClientInformation *temp = ClientInformation::getBegin();
     bool added=false;
     while(temp != NULL){
-      if(temp->getHead()){
-        temp=temp->next();
-        //think this works without continue
-        continue;
-      }
       if( !(temp->getSynched()) ){
         COUT(5) << "Server: not sending gamestate" << std::endl;
         temp=temp->next();
+        if(!temp)
+          break;
         //think this works without continue
         continue;
@@ -266,5 +252,5 @@
       int cid = temp->getID(); //get client id
       COUT(5) << "Server: got acked (gamestate) ID from clientlist: " << gid << std::endl;
-      GameStateCompressed *gs = gamestates->popGameState(cid);
+      packet::Gamestate *gs = gamestates_->popGameState(cid);
       if(gs==NULL){
         COUT(2) << "Server: could not generate gamestate (NULL from compress)" << std::endl;
@@ -272,20 +258,14 @@
       }
       //std::cout << "adding gamestate" << std::endl;
-      ENetPacket *packet = packet_gen.gstate(gs);
-      if(!packet)
-	continue;
-      if ( !(connection->addPacket(packet, cid)) ){
+      gs->setClientID(cid);
+      assert(gs->compressData());
+      if ( !gs->send() ){
         COUT(3) << "Server: packet with client id (cid): " << cid << " not sended: " << temp->getFailures() << std::endl; 
         temp->addFailure();
-        /*if(temp->getFailures() > 0 )
-          disconnectClient(temp);*/
-      //std::cout << "added gamestate" << std::endl;
       }else
         temp->resetFailures();
       added=true;
       temp=temp->next();
-      // now delete gamestate
-      delete[] gs->data;
-      delete gs;
+      // gs gets automatically deleted by enet callback
     }
     /*if(added) {
@@ -296,45 +276,22 @@
     return true;
   }
-
-  void Server::processAck( ack *data, int clientID) {
-    COUT(4) << "Server: processing ack from client: " << clientID << "; ack-id: " << data->a << std::endl;
-    gamestates->ackGameState(clientID, data->a);
-    delete data;
-  }
-  
-  bool Server::processConnectRequest( connectRequest *con, int clientID ){
-    //(COUT(3) << "processing connectRequest " << std::endl;
-    //connection->addPacket(packet_gen.gstate(gamestates->popGameState(clientID)) , clientID);
-    //createClient(clientID);
-    delete con;
-    return true;
-  }
-  
-  void Server::processGamestate( GameStateCompressed *data, int clientID){
-    COUT(4) << "processing partial gamestate from client " << clientID << std::endl;
-    gamestates->addGameState(data, clientID);
-        /*COUT(3) << "Could not push gamestate\t\t\t\t=====" << std::endl;
-    else
-      if(clients->findClient(clientID))
-        clients->findClient(clientID)->resetFailures();*/
-  }
-  
-  void Server::processChat( chat *data, int clientId){
-    char *message = new char [strlen(data->message)+10+1];
-    sprintf(message, "Player %d: %s", clientId, data->message);
-    COUT(1) << message << std::endl;
-    ENetPacket *pck = packet_gen.chatMessage(message);
-    connection->addPacketAll(pck);
-    delete[] data->message;
-    delete data;
-  }
+  
+//   void Server::processChat( chat *data, int clientId){
+//     char *message = new char [strlen(data->message)+10+1];
+//     sprintf(message, "Player %d: %s", clientId, data->message);
+//     COUT(1) << message << std::endl;
+//     ENetPacket *pck = packet_gen.chatMessage(message);
+//     connection->addPacketAll(pck);
+//     delete[] data->message;
+//     delete data;
+//   }
   
   bool Server::addClient(ENetEvent *event){
-    ClientInformation *temp = clients->insertBack(new ClientInformation);
+    ClientInformation *temp = ClientInformation::insertBack(new ClientInformation);
     if(!temp){
       COUT(2) << "Server: could not add client" << std::endl;
       return false;
     }
-    if(temp->prev()->getHead()) { //not good if you use anything else than insertBack
+    if(temp->prev()->getBegin()) { //not good if you use anything else than insertBack
       temp->prev()->setID(0); //bugfix: not necessary but usefull
       temp->setID(1);
@@ -348,5 +305,5 @@
   
   bool Server::createClient(int clientID){
-    ClientInformation *temp = clients->findClient(clientID);
+    ClientInformation *temp = ClientInformation::findClient(clientID);
     if(!temp){
       COUT(2) << "Conn.Man. could not create client with id: " << clientID << std::endl;
@@ -363,5 +320,7 @@
     temp->setSynched(true);
     COUT(3) << "sending welcome" << std::endl;
-    connection->sendWelcome(temp->getID(), temp->getShipID(), true);
+    packet::Welcome *w = new packet::Welcome(temp->getID(), temp->getShipID());
+    w->setClientID(temp->getID());
+    assert(w->send());
     return true;
   }
@@ -376,4 +335,6 @@
     }
     orxonox::SpaceShip *no = dynamic_cast<orxonox::SpaceShip *>(id->fabricate());
+    no->classID = id->getNetworkID();
+    client->setShipID(no->objectID);
     no->setPosition(orxonox::Vector3(0,0,80));
     no->setScale(10);
@@ -388,8 +349,7 @@
     no->setRotDamp(1.0);
     no->setCamera("cam_"+client->getID());
-    no->classID = id->getNetworkID();
     no->create();
+    no->setBacksync(true);
     
-    client->setShipID(no->objectID);
     return true;
   }
@@ -401,5 +361,5 @@
     //boost::recursive_mutex::scoped_lock lock(head_->mutex_);
     orxonox::Iterator<orxonox::SpaceShip> it = orxonox::ObjectList<orxonox::SpaceShip>::start();
-    ClientInformation *client = clients->findClient(&event->peer->address);
+    ClientInformation *client = ClientInformation::findClient(&event->peer->address);
     if(!client)
       return false;
@@ -412,5 +372,5 @@
       ++it;
       delete  *temp;
-      return clients->removeClient(event->peer);
+      return ClientInformation::removeClient(event->peer);
     }
     return false;
@@ -418,5 +378,5 @@
 
   void Server::disconnectClient(int clientID){
-    ClientInformation *client = clients->findClient(clientID);
+    ClientInformation *client = ClientInformation::findClient(clientID);
     if(client)
       disconnectClient(client);
@@ -424,5 +384,5 @@
   void Server::disconnectClient( ClientInformation *client){
     connection->disconnectClient(client);
-    gamestates->removeClient(client);
+    gamestates_->removeClient(client);
   }
   
Index: code/trunk/src/network/Server.h
===================================================================
--- code/trunk/src/network/Server.h	(revision 1639)
+++ code/trunk/src/network/Server.h	(revision 1735)
@@ -46,7 +46,6 @@
 #include <string>
 
-#include "PacketManager.h"
-
-
+#include "Host.h"
+#include "GamestateManager.h"
 
 namespace network
@@ -58,17 +57,16 @@
   * It implements all functions necessary for a Server
   */
-  class _NetworkExport Server : public PacketDecoder{
+  class _NetworkExport Server : public Host{
   public:
-    static Server *createSingleton();
-    static Server *createSingleton(int port);
-    static Server *createSingleton(int port, std::string bindAddress);
-    static Server *createSingleton(int port, const char *bindAddress);
-    
-    static Server *getSingleton();
+    Server();
+    Server(int port);
+    Server(int port, std::string bindAddress);
+    Server(int port, const char *bindAddress);
     
     void open();
     void close();
-    bool sendChat(std::string msg);
-    bool sendChat(const char *msg);
+    bool processChat(packet::Chat *message, unsigned int clientID);
+    bool sendChat(packet::Chat *chat);
+    bool queuePacket(ENetPacket *packet, int clientID);
     void tick(float time);
   protected:
@@ -76,10 +74,6 @@
     void updateGamestate();
   private:
-    Server();
-    Server(int port);
-    Server(int port, std::string bindAddress);
-    Server(int port, const char *bindAddress);
-    
-    static Server *instance_;
+    unsigned int shipID(){return 0;}
+    int playerID(){return 0;}
     
     bool addClient(ENetEvent *event);
@@ -89,14 +83,13 @@
     void disconnectClient(int clientID);
     void disconnectClient( ClientInformation *client);
+    bool processPacket( ENetPacket *packet, ENetPeer *peer );
     bool sendGameState();
-    void processAck( ack *data, int clientID);
-    bool processConnectRequest( connectRequest *con, int clientID );
-    void processGamestate( GameStateCompressed *data, int clientID);
-    void processChat( chat *data, int clientId);
+    
+    
+    //void processChat( chat *data, int clientId);
     ConnectionManager *connection;
-    GameStateManager *gamestates;
-    PacketGenerator packet_gen;
+    GamestateManager *gamestates_;
 
-    ClientInformation *clients;
+    
     float timeSinceLastUpdate_;
   };
Index: code/trunk/src/network/Synchronisable.cc
===================================================================
--- code/trunk/src/network/Synchronisable.cc	(revision 1639)
+++ code/trunk/src/network/Synchronisable.cc	(revision 1735)
@@ -43,7 +43,8 @@
 #include <string>
 #include <iostream>
-#include <string.h>
+#include <assert.h>
 
 #include "core/CoreIncludes.h"
+#include "core/BaseObject.h"
 // #include "core/Identifier.h"
 
@@ -85,4 +86,35 @@
     else  // server
       state_=0x1;
+  }
+  
+  bool Synchronisable::fabricate(unsigned char*& mem, int mode)
+  {
+    unsigned int size, objectID, classID;
+    size = *(unsigned int *)mem;
+    objectID = *(unsigned int*)(mem+sizeof(unsigned int));
+    classID = *(unsigned int*)(mem+2*sizeof(unsigned int));
+    
+    orxonox::Identifier* id = ID(classID);
+    if(!id){
+      COUT(3) << "We could not identify a new object; classid: " << classID << " uint: " << (unsigned int)classID << " objectID: " << objectID << " size: " << size << std::endl;
+      return false; // most probably the gamestate is corrupted
+    }
+    orxonox::BaseObject *bo = id->fabricate();
+    Synchronisable *no = dynamic_cast<Synchronisable *>(bo);
+    assert(no);
+    no->objectID=objectID;
+    no->classID=classID;
+    COUT(3) << "fabricate objectID: " << no->objectID << " classID: " << no->classID << std::endl;
+          // update data and create object/entity...
+    if( !no->updateData(mem, mode) ){
+      COUT(1) << "We couldn't update the object: " << objectID << std::endl;
+      return false;
+    }
+    if( !no->create() )
+    {
+      COUT(1) << "We couldn't manifest (create() ) the object: " << objectID << std::endl;
+      return false;
+    }
+    return true;
   }
 
@@ -109,49 +141,5 @@
   }
 
-  /**
-  * note: only use this function for debug use, because it's inefficient (in order to produce a gamestate, you have to copy the whole data again to another memory location after this process)
-  * This function takes all SynchronisableVariables out of the Synchronisable and saves it into a syncData struct
-  * structure of the bitstream:
-  * (var1_size,var1,var2_size,var2,...)
-  * varx_size: size = sizeof(int)
-  * varx: size = varx_size
-  * @return data containing all variables and their sizes
-  */
-  // syncData Synchronisable::getData(){
-  //   std::list<synchronisableVariable>::iterator i;
-  //   int totalsize=0;
-  //   //figure out size of data to be allocated
-  //   for(i=syncList->begin(); i!=syncList->end(); i++){
-  //     // increase size (size of variable and size of size of variable ;)
-  //     if(i->type == STRING)
-  //       totalsize+=sizeof(int)+((std::string *)i->var)->length()+1;
-  //     else
-  //       totalsize+=sizeof(int)+i->size;
-  //   }
-  //   syncData retVal;
-  //   retVal.objectID=this->objectID;
-  //   retVal.classID=this->classID;
-  //   retVal.length=totalsize;
-  //   // allocate memory
-  //   retVal.data = (unsigned char *)malloc(totalsize);
-  //   // copy to location
-  //   //CHANGED: REMOVED DECLARATION int n=0 FROM LOOP
-  //   int n=0;
-  //   for(i=syncList->begin(); n<totalsize && i!=syncList->end(); i++){
-  //     std::memcpy(retVal.data+n, (const void*)(i->size), sizeof(int));
-  //     n+=sizeof(int);
-  //     switch(i->type){
-  //     case STRING:
-  //       std::memcpy(retVal.data+n, (const void *)(((std::string *)i->var)->c_str()), ((std::string *)i->var)->length()+1);
-  //       n+=((std::string *)i->var)->length()+1;
-  //       break;
-  //     case DATA:
-  //       std::memcpy(retVal.data+n, ((const void*)i->var), i->size);
-  //       n+=i->size;
-  //       break;
-  //     }
-  //   }
-  //   return retVal;
-  // }
+
   /**
   * This function takes all SynchronisableVariables out of the Synchronisable and saves it into a syncData struct
@@ -203,5 +191,106 @@
     return retVal;
   }
-
+  
+  /**
+   * This function takes all SynchronisableVariables out of the Synchronisable and saves it into a syncData struct
+  * Difference to the above function:
+   * takes a pointer to already allocated memory (must have at least getSize bytes length)
+  * structure of the bitstream:
+   * (var1_size,var1,var2_size,var2,...)
+   * varx_size: size = sizeof(int)
+   * varx: size = varx_size
+   * @return data containing all variables and their sizes
+   */
+  bool Synchronisable::getData2(unsigned char*& mem, int mode){
+    //std::cout << "inside getData" << std::endl;
+    unsigned int tempsize = 0;
+    if(mode==0x0)
+      mode=state_;
+    if(classID==0)
+      COUT(3) << "classid 0 " << this->getIdentifier()->getName() << std::endl;
+    this->classID=this->getIdentifier()->getNetworkID();
+    std::list<synchronisableVariable *>::iterator i;
+    unsigned int size;
+    size=getSize2(mode);
+    
+    // start copy header
+    memcpy(mem, &size, sizeof(unsigned int));
+    mem+=sizeof(unsigned int);
+    memcpy(mem, &(this->objectID), sizeof(unsigned int));
+    mem+=sizeof(unsigned int);
+    memcpy(mem, &(this->classID), sizeof(unsigned int));
+    mem+=sizeof(unsigned int);
+    tempsize+=12;
+    // end copy header
+    
+    
+    COUT(5) << "Synchronisable getting data from objectID: " << objectID << " classID: " << classID << " length: " << size << std::endl;
+    // copy to location
+    for(i=syncList->begin(); i!=syncList->end(); ++i){
+      //(std::memcpy(retVal.data+n, (const void*)(&(i->size)), sizeof(int));
+      if( ((*i)->mode & mode) == 0 ){
+        COUT(5) << "not getting data: " << std::endl;
+        continue;  // this variable should only be received
+      }
+      switch((*i)->type){
+        case DATA:
+          memcpy( (void *)(mem), (void*)((*i)->var), (*i)->size);
+          mem+=(*i)->size;
+          tempsize+=(*i)->size;
+          break;
+        case STRING:
+          memcpy( (void *)(mem), (void *)&((*i)->size), sizeof(int) );
+          mem+=sizeof(int);
+          const char *data = ( ( *(std::string *) (*i)->var).c_str());
+          memcpy( mem, (void*)data, (*i)->size);
+          COUT(5) << "synchronisable: char: " << (const char *)(mem) << " data: " << data << " string: " << *(std::string *)((*i)->var) << std::endl;
+          mem+=(*i)->size;
+          tempsize+=(*i)->size + 4;
+          break;
+      }
+    }
+    assert(tempsize==size);
+    return true;
+  }
+
+  /*bool Synchronisable::getData(Bytestream& bs, int mode)
+  {
+    //std::cout << "inside getData" << std::endl;
+    if(mode==0x0)
+      mode=state_;
+    if(classID==0)
+      COUT(3) << "classid 0 " << this->getIdentifier()->getName() << std::endl;
+    this->classID=this->getIdentifier()->getNetworkID();
+    std::list<synchronisableVariable *>::iterator i;
+    bs << this->getSize();
+    bs << this->objectID;
+    bs << this->classID;
+    // copy to location
+    for(i=syncList->begin(); i!=syncList->end(); ++i){
+      if( ((*i)->mode & mode) == 0 ){
+        COUT(5) << "not getting data: " << std::endl;
+        continue;  // this variable should only be received
+      }
+      switch((*i)->type){
+        case DATA:
+          bs << *(*i)->var;
+          //std::memcpy( (void *)(retVal.data+n), (void*)((*i)->var), (*i)->size);
+          //n+=(*i)->size;
+          break;
+        case STRING:
+          bs << *(String *)((*i)->var);
+          //memcpy( (void *)(retVal.data+n), (void *)&((*i)->size), sizeof(int) );
+          //n+=sizeof(int);
+          //const char *data = ( ( *(std::string *) (*i)->var).c_str());
+          //std::memcpy( retVal.data+n, (void*)data, (*i)->size);
+          //COUT(5) << "synchronisable: char: " << (const char *)(retVal.data+n) << " data: " << data << " string: " << *(std::string *)((*i)->var) << std::endl;
+          //n+=(*i)->size;
+          break;
+      }
+    }
+    return true;
+  }*/
+
+  
   /**
   * This function takes a syncData struct and takes it to update the variables
@@ -247,5 +336,67 @@
       }
       // call the callback function, if defined
-      if(callback)
+      if(callback && (*i)->callback)
+        (*i)->callback->call();
+    }
+    return true;
+  }
+  
+  /**
+   * This function takes a syncData struct and takes it to update the variables
+   * @param vars data of the variables
+   * @return true/false
+   */
+  bool Synchronisable::updateData(unsigned char*& mem, int mode){
+    unsigned char *data = mem;
+    if(mode==0x0)
+      mode=state_;
+    std::list<synchronisableVariable *>::iterator i;
+    if(syncList->empty()){
+      COUT(4) << "Synchronisable::updateData syncList is empty" << std::endl;
+      return false;
+    }
+    
+    // start extract header
+    unsigned int objectID, classID, size;
+    size = *(int *)mem;
+    mem+=sizeof(size);
+    objectID = *(int *)mem;
+    mem+=sizeof(objectID);
+    classID = *(int *)mem;
+    mem+=sizeof(classID);
+    // stop extract header
+    assert(this->objectID==objectID);
+    assert(this->classID==classID);
+    
+    COUT(5) << "Synchronisable: objectID " << objectID << ", classID " << classID << " size: " << size << " synchronising data" << std::endl;
+    for(i=syncList->begin(); i!=syncList->end() && mem <= data+size; i++){
+      if( ((*i)->mode ^ mode) == 0 ){
+        COUT(5) << "synchronisable: not updating variable " << std::endl;
+        continue;  // this variable should only be set
+      }
+      COUT(5) << "Synchronisable: element size: " << (*i)->size << " type: " << (*i)->type << std::endl;
+      bool callback=false;
+      switch((*i)->type){
+        case DATA:
+          if((*i)->callback) // check whether this variable changed (but only if callback was set)
+            if(strncmp((char *)(*i)->var, (char *)mem, (*i)->size)!=0)
+              callback=true;
+          memcpy((void*)(*i)->var, mem, (*i)->size);
+          mem+=(*i)->size;
+          break;
+        case STRING:
+          (*i)->size = *(int *)mem;
+          COUT(5) << "string size: " << (*i)->size << std::endl;
+          mem+=sizeof(int);
+          if((*i)->callback) // check whether this string changed
+            if( *(std::string *)((*i)->var) != std::string((char *)mem) )
+              callback=true;
+          *((std::string *)((*i)->var)) = std::string((const char*)mem);
+          COUT(5) << "synchronisable: char: " << (const char*)mem << " string: " << std::string((const char*)mem) << std::endl;
+          mem += (*i)->size;
+          break;
+      }
+      // call the callback function, if defined
+      if(callback && (*i)->callback)
         (*i)->callback->call();
     }
@@ -280,4 +431,26 @@
   }
 
+  /**
+   * This function returns the total amount of bytes needed by getData to save the whole content of the variables
+   * @return amount of bytes
+   */
+  int Synchronisable::getSize2(int mode){
+    return 3*sizeof(unsigned int) + getSize( mode );
+  }
+  
+  bool Synchronisable::isMyData(unsigned char* mem)
+  {
+    unsigned int objectID, classID, size;
+    size = *(int *)mem;
+    mem+=sizeof(size);
+    objectID = *(int *)mem;
+    mem+=sizeof(objectID);
+    classID = *(int *)mem;
+    mem+=sizeof(classID);
+    
+    assert(classID == this->classID);
+    return (objectID == this->objectID);
+  }
+  
   void Synchronisable::setBacksync(bool sync){
     backsync_=sync;
Index: code/trunk/src/network/Synchronisable.h
===================================================================
--- code/trunk/src/network/Synchronisable.h	(revision 1639)
+++ code/trunk/src/network/Synchronisable.h	(revision 1735)
@@ -44,12 +44,12 @@
 
   struct syncData{
-    int length;
-    int objectID;
-    int classID;
+    unsigned int length;
+    unsigned int objectID;
+    unsigned int classID;
     unsigned char *data;
   };
 
   typedef struct synchronisableVariable{
-    int size;
+    unsigned int size;
     int mode; // this determines in which direction the variable gets synchronised
     void *var;
@@ -69,12 +69,17 @@
 
     virtual ~Synchronisable();
-    int objectID;
-    int classID;
+    unsigned int objectID;
+    unsigned int classID;
 
     void registerVar(void *var, int size, variableType t, int mode=1, NetworkCallbackBase *cb=0);
     //  syncData getData();
     syncData getData(unsigned char *mem, int mode=0x0);
+    bool getData2(unsigned char*& men, int mode=0x0);
+    //bool getData(Bytestream& bs, int mode=0x0);
     int getSize(int mode=0x0);
+    int getSize2(int mode=0x0);
     bool updateData(syncData vars, int mode=0x0);
+    bool updateData(unsigned char*& mem, int mode=0x0);
+    bool isMyData(unsigned char* mem);
     void setBacksync(bool sync);
     bool getBacksync();
@@ -82,4 +87,6 @@
     virtual bool create();
     static void setClient(bool b);
+    
+    static bool fabricate(unsigned char*& mem, int mode=0x0);
   protected:
     Synchronisable();
Index: code/trunk/src/network/packet/Acknowledgement.cc
===================================================================
--- code/trunk/src/network/packet/Acknowledgement.cc	(revision 1735)
+++ code/trunk/src/network/packet/Acknowledgement.cc	(revision 1735)
@@ -0,0 +1,75 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#include "Acknowledgement.h"
+#include "network/Host.h"
+#include "network/GamestateHandler.h"
+
+namespace network {
+namespace packet {
+
+#define PACKET_FLAGS_ACK    0
+#define _PACKETID           0
+#define _ACKID              _PACKETID + sizeof(network::packet::ENUM::Type)
+  
+Acknowledgement::Acknowledgement( unsigned int id, int clientID )
+ : Packet()
+{
+  flags_ = flags_ | PACKET_FLAGS_ACK;
+  data_=new unsigned char[ getSize() ];
+  *(ENUM::Type *)(data_ + _PACKETID ) = ENUM::Acknowledgement;
+  *(unsigned int *)&data_[ _ACKID ] = id;
+  clientID_=clientID;
+}
+
+Acknowledgement::Acknowledgement( unsigned char *data, int clientID )
+  : Packet(data, clientID)
+{
+}
+
+Acknowledgement::~Acknowledgement()
+{
+}
+
+unsigned int Acknowledgement::getSize() const{
+  return _ACKID + sizeof(unsigned int);
+}
+
+bool Acknowledgement::process(){
+  bool b = GamestateHandler::ackGamestate(data_[_ACKID], clientID_);
+  delete this;
+  return b;
+}
+
+unsigned int Acknowledgement::getAckID(){
+  return *(unsigned int *)&data_[ _ACKID ];
+}
+
+} //namespace packet
+} //namespace network
